class ItemProcessor
  attr_reader :source, :context

  def initialize(source, context)
    @source = source.dup
    @context = context
  end

  def perform
    items = source.scan /({{(.+?)}})/m
    items.each do |replace, key|
      source.gsub! replace, context.indifferent_fetch(key).to_s
    end
    source
  end
end
